diff -r 9c08d8b8d275 AuthoringTool/src/com/oracle/javafx/authoring/Deprecation.java
--- a/AuthoringTool/src/com/oracle/javafx/authoring/Deprecation.java	Tue Jul 03 08:40:46 2012 +0200
+++ b/AuthoringTool/src/com/oracle/javafx/authoring/Deprecation.java	Tue Jul 03 22:32:49 2012 +0200
@@ -83,7 +83,7 @@
 
     // RT-21206 : Promote impl_impl_processCSS to public API
     public static void processCSS(Node node, boolean process) {
-        node.impl_processCSS(process);
+       // node.impl_processCSS(process);
     }
     
     // RT-22562
diff -r 9c08d8b8d275 AuthoringTool/src/com/oracle/javafx/authoring/Frame.java
--- a/AuthoringTool/src/com/oracle/javafx/authoring/Frame.java	Tue Jul 03 08:40:46 2012 +0200
+++ b/AuthoringTool/src/com/oracle/javafx/authoring/Frame.java	Tue Jul 03 22:32:49 2012 +0200
@@ -103,7 +103,7 @@
             // Title area composed of SelectionBar and Messages indicator
             selectionBar = new MessagePanel(Frame.this);
             // StackPane is required to have the transient message displayed on top of the SelectionBar.
-            getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.MESSAGE_BAR_CSS);
+            //getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.MESSAGE_BAR_CSS);
             getStyleClass().addAll(CssUtils.SCENE_BUILDER_THEME_STYLECLASS, "top-panel"); //NOI18N
             final HBox title = new HBox(1);
             getChildren().add(title);
@@ -895,7 +895,7 @@
         
         applicationMenu = new ApplicationMenu(this);
         final VBox vbox = new VBox();
-        vbox.getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.TOOL_ROOT_CSS);
+        //vbox.getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.TOOL_ROOT_CSS);
         vbox.getStyleClass().add(CssUtils.SCENE_BUILDER_THEME_STYLECLASS);
         vbox.getChildren().addAll(applicationMenu.getMenuBar(), contentPanel);
         VBox.setVgrow(contentPanel, Priority.ALWAYS);
@@ -905,7 +905,7 @@
 
         final VBox center = new VBox();
         final List<String> origStyleClass = Utils.newList(center.getStyleClass());
-        center.getStylesheets().add(CssUtils.CONTENT_VIEW_CSS);
+        //center.getStylesheets().add(CssUtils.CONTENT_VIEW_CSS);
         updateCenterStyleClasses(center, origStyleClass);
         SBPreferences.getPreferences().backgroundStyleClass().addListener(new ChangeListener<SBPreferences.BG_STYLE_CLASS>(){
 
diff -r 9c08d8b8d275 AuthoringTool/src/com/oracle/javafx/authoring/internal/AreaPanel.java
--- a/AuthoringTool/src/com/oracle/javafx/authoring/internal/AreaPanel.java	Tue Jul 03 08:40:46 2012 +0200
+++ b/AuthoringTool/src/com/oracle/javafx/authoring/internal/AreaPanel.java	Tue Jul 03 22:32:49 2012 +0200
@@ -331,7 +331,7 @@
         final LibraryPanel libraryPanel = new LibraryPanel(frame);
         libraryPanel.setId(QEConstants.ID_LEFT_TAB_PANE_TOP);
         libraryPanel.getStyleClass().addAll(CssUtils.SCENE_BUILDER_THEME_STYLECLASS, "library"); //NOI18N
-        libraryPanel.getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.LIBRARY_CSS);
+      //  libraryPanel.getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.LIBRARY_CSS);
 
         Panel panelTop = new Panel(LIBRARY_PANEL, libraryPanel);
         panels.add(panelTop);
@@ -342,7 +342,7 @@
         final HierarchyPanel layerPanel = new HierarchyPanel(frame);
         layerPanel.setId(QEConstants.ID_LEFT_TAB_PANE_BOTTOM);
         layerPanel.getStyleClass().addAll(CssUtils.SCENE_BUILDER_THEME_STYLECLASS, "hierarchy"); //NOI18N
-        layerPanel.getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.HIERARCHY_CSS);
+        //layerPanel.getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.HIERARCHY_CSS);
 
         Panel panelBottom = new Panel(HIERARCHY_PANEL, layerPanel);
         panels.add(panelBottom);
@@ -357,7 +357,7 @@
         final InspectorPanel inspectorPanel = new InspectorPanel(frame);
         inspectorPanel.setId(QEConstants.ID_RIGHT_TAB_PANE);
         inspectorPanel.getStyleClass().addAll(CssUtils.SCENE_BUILDER_THEME_STYLECLASS, "info"); //NOI18N
-        inspectorPanel.getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.INSPECTOR_CSS);
+       // inspectorPanel.getStylesheets().addAll(CssUtils.THEME_CSS, CssUtils.INSPECTOR_CSS);
 
         Panel panelRight = new Panel(INSPECTOR_PANEL, inspectorPanel);
         panels.add(panelRight);